// Code generated by github.com/99designs/gqlgen, DO NOT EDIT.

package gqlmodel

import (
	"fmt"
	"io"
	"strconv"
)

type Comment struct {
	ID   string `json:"id"`
	Text string `json:"text"`
}

type Game struct {
	ID         string      `json:"id"`
	CreatedAt  string      `json:"createdAt"`
	IsFinished bool        `json:"isFinished"`
	Comments   []Comment   `json:"comments"`
	Scoreboard *Scoreboard `json:"scoreboard"`
}

type Player struct {
	Nickname string `json:"nickname"`
	Role     Role   `json:"role"`
	IsAlive  bool   `json:"isAlive"`
	KillCounter    int    `json:"killCounter"`
}

type Scoreboard struct {
	Players []Player `json:"users"`
}

type Role string

const (
	RoleCitizen Role = "CIVILIAN"
	RoleMafia    Role = "MAFIA"
)

var AllRole = []Role{
	RoleCitizen,
	RoleMafia,
}

func (e Role) IsValid() bool {
	switch e {
	case RoleCitizen, RoleMafia:
		return true
	}
	return false
}

func (e Role) String() string {
	return string(e)
}

func (e *Role) UnmarshalGQL(v interface{}) error {
	str, ok := v.(string)
	if !ok {
		return fmt.Errorf("enums must be strings")
	}

	*e = Role(str)
	if !e.IsValid() {
		return fmt.Errorf("%s is not a valid Role", str)
	}
	return nil
}

func (e Role) MarshalGQL(w io.Writer) {
	fmt.Fprint(w, strconv.Quote(e.String()))
}
